/* CONSTANT DEFINE */
#define	fSIZE		4	
#define	dSIZE		8
#define	HBUFSIZE	4096	
#define	MAX_LAYER	10
#define	LAST		0
#define	SIGMOID		'S'
#define	LINEAR		'L'
#define	APPEND		'A'
#define	NO_APPEND	'N'
#define	OVERWRITE	'O'	
#define	RECORD		'R'	
#define	DATAPOINT	'D'
#define	RANDUM		'R'
#define	JIA		'J'
#define	SET_LEARN	'S'	
#define	PATTERN_LEARN	'P'	
#define	STEEP		'1'	
#define	MOMENTUM	'2'	
#define	VOGL		'3'	
#define	JACOB		'4'	
#define	MOMENTUM2	'5'	
#define OCHI		'6'

/* To structure learning */
/* Modified by higashi   */
#define PLAUT            1
#define ISHIKAWA         2
#define YASUI            3
/* end of Modified       */

#define	Getintoplist(point)	((point)->InTopList)
#define	Getinfwdlist(point) 	((point)->InFwdList)
#define	Getinbwdlist(point) 	((point)->InBwdList)
#define	Getouttoplist(point) 	((point)->OutTopList)
#define	Getoutfwdlist(point) 	((point)->OutFwdList)
#define	Getoutbwdlist(point) 	((point)->OutBwdList)
#define Getouttolist(point) 	((point)->OutToList)
#define	CheckBias(lay_no) 	(FuncBias[(lay_no)][1] == APPEND)

/* SYSTEM PARAMETER */
struct	bps_pr {
  int    NumOfLayer;		      /* number of layer */
  int    NumOfCell[MAX_LAYER];	      /* number of each layer's cell */
  char   FuncBias[MAX_LAYER][5];      /* status of char.func and bias */
  char   InitAlgo;		      /* initialize algorithm */
  char   InitWgtFile[FILE_LENGTH];    /* initialize data file name made
					 by init. command */
  int	 Seed;                        /* seed */
  double MaxInitWgt;                  /* maximum of initialize data */
  double MinInitWgt;                  /* minimum of initialize data */
  char   LearnMode;		      /* learning mode */
  char   LearnAlgo;		      /* learning algorithm */
  char   LrnInitWgtFile[FILE_LENGTH]; /* initialize weight for learn command */
  char   WgtHistoryFile[FILE_LENGTH]; /* weight history file name */
  int    WgtStorInterval;             /* weight store interval */
  char   WgtStorMode;                 /* weight history store mode */
  char   ErrHistoryFile[FILE_LENGTH]; /* error history file name */
  int    ErrStorInterval;             /* error store interval */
  char   ErrStorDirection;            /* store direction for error */
  char   ErrStorMode;                 /* store mode for error */
  char   InputFile[FILE_LENGTH];      /* input data file name for learning */
  char   TeachFile[FILE_LENGTH];      /* teach data file name for learning */
  int    LrnFirstPtrn;                /* first pattern number of learning */
  int    LrnLastPtrn;                 /* last pattern number of learning */
  double LearnRate;                   /* learning rate */
  double Momentum;                    /* momentum */
  double IncreaseFact;                /* increasing factor for learn. rate */
  double ReductFact;                  /* reduction factor for learn. rate */
  double VoglThresh;                  /* threshold for Vogl method */
  double Theta;                       /* for Ochiai's method */
  double MinError;                    /* min. error for end */
  int    MaxLearnCount;               /* max. learn count for end */
  int    DisplayInterval;             /* display interval (console) */
  char   Comment[FILE_LENGTH];        /* comment */
  char   TestWgtFile[FILE_LENGTH];    /* weight file name for test */
  int    WgtHistoryNo;                /* weight history number */
  char   TestFile[FILE_LENGTH];       /* test data file name */
  int    TestFirstPtrn;               /* first pattern number of test */
  int    TestLastPtrn;                /* last pattern number of test */
  int	 InputLayer;                  /* input layer No. */
  int	 OutputLayer;                 /* output layer No. */
  char	 ActFile[FILE_LENGTH];        /* result file name */
  /* structure learing Parameters     */
  /* modified by higashi */
  int    StrLrnMode;                  /* structure learning mode*/
  double Ramuda;                      /* Structure Learning Param */
  /* end of modified */
};

/* NETWORK STRUCTURE */
struct	cel {                         /* cell node */
  struct i_lin	*InTopList;           /* pointer to inp. link list */
  struct o_lin	*OutTopList;          /* pointer to outp. link list */
  char           CharFunc;            /* characteristic function */
  double         Active;              /* cell activation */
  double         Delta;               /* work for weight adjust(delta)*/
  double         Net;	              /* sum of all inputs */
  int            SelFlg;              /* for BPTRC */
};

struct i_lin {                        /* node of cell inputs list */
  struct i_lin  *InFwdList;           /* pointer to foward link list */
  struct i_lin  *InBwdList;           /* pointer to backward link list */
  struct cel    *InputCell;           /* input from */
  struct cel    *NodeCell;            /* top of this list */
  double         Weight;              /* weight for link */
  double         AdjWgt;              /* work for weight adjust */
  double         WgtWork;             /* work for weight adjust */
  double         CoefLearn;           /* learning factor(eta) */
  double         dltold;              /**************************************/
  double         dltwgtold;           /*                                    */
  double         wgtworkold;          /*      for Ochiai's method           */
  double         dltwork;             /*                                    */
  double         dltworkold;          /**************************************/
};

struct o_lin {                        /* node of cell outputs list */
  struct o_lin  *OutFwdList;          /* pointer to forward list */
  struct o_lin  *OutBwdList;          /* pointer to backward list */
  struct i_lin  *OutToList;           /* output to */
};

struct lay {                          /* layer information for BP model*/
  int            CellNo;              /* cell number */
  struct cel    *CellNode;            /* pointer to cell node */
};


typedef struct bps_pr bpspr_t;
typedef struct cel    cel_t;
typedef struct i_lin  ilin_t;
typedef struct o_lin  olin_t;
typedef struct lay    lay_t;
