/* lib/bpsmalloc.c */
extern char   **malloc2D    _ANSI_ARGS_((int n, int m, size_t sz));
extern void     _free2D     _ANSI_ARGS_((char **data));
#define         free2D(x)   (_free2D((char **)(x)))

/* lib/rwbps.c */
extern  int     rebps       _ANSI_ARGS_((void));
extern  int     wrbps       _ANSI_ARGS_((void));

/* lib/getparam.c */
extern  void    GetStructureParameters    _ANSI_ARGS_((void));
extern  void    PrintStructureParameters  _ANSI_ARGS_((void));
extern  void    GetInitializeParameters   _ANSI_ARGS_((void));
extern  void    PrintInitializeParameters _ANSI_ARGS_((void));
extern  void    GetLearningParameters     _ANSI_ARGS_((void));
extern  void    PrintLearningParameters   _ANSI_ARGS_((void));
extern  void    GetTestingParameters      _ANSI_ARGS_((void));
extern  void    PrintTestingParameters    _ANSI_ARGS_((void));

/* lib/charfunc.c */
extern  double  Sigmoid     _ANSI_ARGS_((double x));
extern  double  d_sig       _ANSI_ARGS_((double x));
extern  double  Linear      _ANSI_ARGS_((double x));
extern  double  d_lin       _ANSI_ARGS_((void));
extern  double  FuncSelect  _ANSI_ARGS_((int function, double in_data));
extern  double  DiffSelect  _ANSI_ARGS_((int function, double in_data));

/* lib/filehndl.c */
extern  void    SetNumOfLink      _ANSI_ARGS_((void));
extern  int     GetNumOfRecord    _ANSI_ARGS_((char filename[]));
extern  int     LastWgtHistory    _ANSI_ARGS_((char filename[]));
extern  int     NextWgtHistory    _ANSI_ARGS_((char filename[]));
extern  int     NextErrHistory    _ANSI_ARGS_((char filename[]));
extern  void    CleanHistArray    _ANSI_ARGS_((float *hist_arry));
extern  void    ReadData          _ANSI_ARGS_((char filename[], float **data,
					       int first_ptrn, int last_ptrn,
					       int num_cell));
extern  void    WriteWeight2      _ANSI_ARGS_((char filename[], int hist_no,
					       double *data));
extern  void    StoreWeight2      _ANSI_ARGS_((char filename[],
					       int wgt_stor_cnt));
extern  void    WriteErrDataPoint _ANSI_ARGS_((char filename[], int hist_no,
					       int position, double data));
extern  void    WriteErrRecord    _ANSI_ARGS_((char *filename, int hist_no));
extern  void    StoreErrRecord    _ANSI_ARGS_((char filename[],
					       int err_stor_cnt));
extern  void    WriteActivation   _ANSI_ARGS_((int hist_no));
extern  int     StoreOldError     _ANSI_ARGS_((char filename[], int hist_no));
extern  void    CreateFile1       _ANSI_ARGS_((char filename[], char temp[]));
extern  void    CreateFile2       _ANSI_ARGS_((char filename[], char temp[],
					       int stor_mode));
extern  void    CreateFile3       _ANSI_ARGS_((char filename[], char temp[],
					       int stor_mode));

/* lib/nethndl.c */
extern  ilin_t *inter_ilin     _ANSI_ARGS_((cel_t *from_cell, cel_t *to_cell));
extern  olin_t *inter_olin     _ANSI_ARGS_((cel_t *from_cell, cel_t *to_cell));
extern  void    SetWeight      _ANSI_ARGS_((cel_t *from_cell, cel_t *to_cell,
					    double weight));
extern  double  GetWeight      _ANSI_ARGS_((cel_t *from_cell, cel_t *to_cell));
extern  void    SetDeltaWgt    _ANSI_ARGS_((cel_t *from_cell, cel_t *to_cell,
					    double deltaw));
extern  cel_t  *make_cell      _ANSI_ARGS_((void));
extern  void    Connect        _ANSI_ARGS_((cel_t *from_cell, cel_t *to_cell));
extern  void    MakeNetwork    _ANSI_ARGS_((void));
extern  void    BreakNetwork   _ANSI_ARGS_((void));
extern  void    ReadWeight2    _ANSI_ARGS_((char filename[], int hist_no));
extern  void    netdump        _ANSI_ARGS_((void));
extern  void    cut            _ANSI_ARGS_((cel_t *from_cell, cel_t *to_cell));
extern  void    wgt_dread      _ANSI_ARGS_((char filename[], int hist_no,
					    double maxary[], double minary[]));

/* lib/learnlib.c */
extern  void    workspace_initialize   _ANSI_ARGS_((void));
extern  void    system_initialize      _ANSI_ARGS_((void));
extern  void    system_end             _ANSI_ARGS_((void));
extern  double  forward_learn          _ANSI_ARGS_((float *inputdata,
						    float *teachdata));
extern  void    backward_learn         _ANSI_ARGS_((void));

/* lib/reclib.c */
extern  void    rec_system_initialize  _ANSI_ARGS_((void));
extern  void    rec_system_end         _ANSI_ARGS_((void));
extern  void    test_network           _ANSI_ARGS_((float in_data[]));
