/*****************************************************************************

                       NCSSP : FUNCTION DECLARATION TABEL


    $Id: ncssfdl.h,v 1.1.1.1 2004/03/26 14:57:15 orrisroot Exp $

*****************************************************************************/

#ifndef _NCSSFDL_H_ 
#define _NCSSFDL_H_ 

/* lib/mlib/ncssfunc.c */
extern  void ncsf_scset		_ANSI_ARGS_(( int *dpoint, 
					      int *calc_end, 
					      int *str_period, 
					      float *report_end ));
extern  void ncsf_initset	_ANSI_ARGS_(( void ));
extern  void ncsf_moniset	_ANSI_ARGS_(( char *moni_vflag ));
extern  void ncsf_startsign	_ANSI_ARGS_(( void ));
extern  void ncsf_repostart	_ANSI_ARGS_(( void ));
extern  void ncsf_dataout	_ANSI_ARGS_(( char *moni_vflag, int index, 
					      int strd_cnt ));
extern  void ncsf_repoprogress	_ANSI_ARGS_(( int calc_cnt, 
					      float report_end ));
extern  void ncsf_endsign	_ANSI_ARGS_(( void ));
extern  void ncsf_repoend	_ANSI_ARGS_(( void ));
extern  void ncsf_xinset	_ANSI_ARGS_(( int nxinc, 
					      struct xin_info *xin_data, 
					      struct xfp_info *xfp_data, 
					      double (**xinfunc)() ));
extern  void ncsf_update	_ANSI_ARGS_(( int nt, int *nctbl, 
					      double **out_ptr, 
					      double **tmp_ptr ));

/* lib/mlib/ncssrscf.c */ 
extern  int ncsf_rdmat		_ANSI_ARGS_(( char *scfn ));
extern  int ncsf_rdprm		_ANSI_ARGS_(( char *scfn ));
extern  int ncsf_rdxinfo	_ANSI_ARGS_(( char *scfn ));
extern  int ncsf_rdout		_ANSI_ARGS_(( char *scfn ));
extern  int ncsf_rddly		_ANSI_ARGS_(( char *scfn ));
extern  void ncsf_FreeOutBuffer	_ANSI_ARGS_(( void ));

/* lib/mlib/ncsslib.c */ 
extern  double ncsl_intgrl	_ANSI_ARGS_(( double init, double y, 
					      double f_old ));
extern  double ncsl_differ	_ANSI_ARGS_(( double init, double y, 
					      double y_old ));
extern  double ncsl_ramp	_ANSI_ARGS_(( double init_out, 
					      double rampup_tm, 
					      double gradient, 
					      double dummy1, double dummy2 ));
extern  double ncsl_pulse	_ANSI_ARGS_(( double start_tm, 
					      double init_out, 
					      double height, double width, 
					      double period ));
extern  double ncsl_sigmoid	_ANSI_ARGS_(( double a ));
extern  double ncsl_thold	_ANSI_ARGS_(( double input, double theta ));
extern  double ncsl_rcab	_ANSI_ARGS_(( double c1, double c2, 
					      double c3, double c4, 
					      double c5, double c6, 
					      double c7, double V ));

/* lib/mlib/ncssutil.c */ 
extern  void init_queue		_ANSI_ARGS_(( double *q, long qsize, 
					      double init ));
extern  double delay		_ANSI_ARGS_(( double *q, long *ptr, 
					      long qsize, double in ));
extern  char **alloc2d		_ANSI_ARGS_(( int m, int n, int size ));
extern  void free2d		_ANSI_ARGS_(( char **f, int m ));

/* lib/mlib/ncssintg.c */ 
extern  void AdapIntgrl		_ANSI_ARGS_(( void (*cf)(), double tstart, 
					      double tstep, int cell, 
					      int neqn, double **y, 
					      double *relerr, int *iflag ));
extern  void EulerIntgrl	_ANSI_ARGS_(( void (*cf)(), double t, 
					      double h, int cell, int neqn, 
					      double **y, double *relerr, 
					      int *iflag ));
extern  void RKG4Intgrl		_ANSI_ARGS_(( void (*cf)(), double t, 
					      double h, int cell, int neqn, 
					      double **y, double *relerr, 
					      int *iflag ));

#ifdef SATELLITE 

/* lib/slib/ncsssate.c */
extern  int ncsf_scfread	_ANSI_ARGS_(( void ));
extern  void ncsf_memalloc	_ANSI_ARGS_(( int nbuff, int dpoint ));
extern  void ncsf_strd		_ANSI_ARGS_(( int nstrd, int mem_index, 
					      double **dptr ));
extern  void ncsf_StoreData	_ANSI_ARGS_(( int dpoint, int nstrd ));

/* ncssbuff.c */
extern  void LagInterp		_ANSI_ARGS_(( double t0, double *xdata, 
					      double *ydata ));
extern  double ncsl_interp	_ANSI_ARGS_(( double pos, double buf_dim, 
					      double dummy0, double dummy1, 
					      double dummy2 ));
extern  PLPointer add_exbuf_info _ANSI_ARGS_(( PList buffinfo, 
					       PLPointer buffinfo_p, 
					       int buffnum, 
					       char *datafile, 
					       int timeid, 
					       char *timefile ));
extern  PLPointer remove_exbuf_info _ANSI_ARGS_(( PList buffinfo, 
						 PLPointer point ));
extern  void remove_all_exbuf_info _ANSI_ARGS_(( PList buffinfo ));

#else

/* NCSSISPP.FDL */ 
extern  int wrcom1();
extern  int recom1();
extern  int wrcom2();
extern  int recom2();
extern  void ncsf_strd();
extern  void ncsf_binfset();
extern  void ncsf_dsave();

#endif /* SATELLITE */

#endif /* _NCSSFDL_H_ */
