/******************************************************************************

        		NCS UTILITY  PROGRAM

    $Id: ncssutil.c,v 1.1.1.1 2004/03/26 14:57:15 orrisroot Exp $

******************************************************************************/

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif /* HAVE_CONFIG_H */

#include <stdio.h>
#ifdef HAVE_STDLIB_H
#include <stdlib.h>
#endif /* HAVE_STDLIB_H */
#ifdef HAVE_MALLOCK_H
#include <malloc.h>
#endif /* HAVE_MALLOCK_H */

#include "ncsdef.h"
#include "common.h"
#include "comlib.h"
#include "ncssstrc.h"
#include "ncssfdl.h"

extern long     ncsg_qsize[];
extern double   ncsg_dlyinit[];

void 
init_queue(q, qsize, init)
long	qsize;
double  *q, init;
{
	register int   i;

	for( i = 0; i < qsize; i++ ){
	  q[i] = init;
	}
}



double 
delay( q, ptr, qsize, in )
long  	qsize, *ptr;
double  *q, in;
{
	double	out;


	if( qsize == 0 ){
	  return( in );
	}

	out = q[*ptr];
	q[(*ptr)++] = in;

	if( *ptr == qsize ){
	  *ptr = 0;
	}
	return( out );
}


char          **
alloc2d( m, n, size )
int	m, n, size;
{
	int 	i;
	char    **f;


	f = (char **) malloc(m * sizeof(char *));
	if( f == NULL ){
	  printf( ">>>Memory Allocation Error<<<" );
	  exit(213);
	}

	for( i = 0; i < m; i++ ){
	  if( n != 0 ){
	    f[i] = (char *) calloc(n, size);
	    if( f[i] == NULL ){
	      printf( ">>>Memory Allocation Error<<<" );
	      exit(213);
	    }
	  } else {
	    f[i] = NULL;
	  }
	}

	return( f );
}


void
free2d( f, m )
char 	**f;
int     m;
{
	int	i;

	free( f );
	for( i = 0; i < m; i++ ){
	  free( f[i] );
	}
}

