#ifndef _ISOP_PROTO_H_
#define _ISOP_PROTO_H_

#undef _ANSI_ARGS_
#if ( defined(__STDC__) && !defined(NO_PROTOTYPE)) || defined(USE_PROTOTYPE)
#   define _USING_PROTOTYPES_ 1
#   define _ANSI_ARGS_(x)       x
#else
#   define _ANSI_ARGS_(x)       ()
#endif

/* in cutdt_func.c */
extern void cutdt_func       _ANSI_ARGS_((Widget w, int *tag,
					  XmAnyCallbackStruct *callback_data));
extern void exit_cutdt       _ANSI_ARGS_((Widget w, int *tag,
					  XmAnyCallbackStruct *callback_data));
extern void exitCutdtOK      _ANSI_ARGS_((Widget w, int *tag,
					  XmAnyCallbackStruct *callback_data));
extern void writeCutData     _ANSI_ARGS_((Widget w, int *tag,
					  XmAnyCallbackStruct *callback_data));
extern void writeCutdtOK     _ANSI_ARGS_((Widget w,
					  caddr_t tag1, caddr_t tag2));
extern void in_cut_data      _ANSI_ARGS_((Widget w, caddr_t tag,
					  caddr_t callback_data));
extern void cut_init         _ANSI_ARGS_((void));
extern void resize_bar       _ANSI_ARGS_((void));
extern void cut_set          _ANSI_ARGS_((Widget w, int *tag,
					  caddr_t callback_data));
extern void cut_point_set    _ANSI_ARGS_((Widget w, XtPointer client_data,
					  XEvent *event));
extern void cut_point_move   _ANSI_ARGS_((Widget w, XtPointer client_data,
					  XEvent *event));
extern void cut_point_other  _ANSI_ARGS_((Widget w, XtPointer client_data,
					  XEvent *event));
extern void cut_out            _ANSI_ARGS_((void));
extern void cutRewriteValue    _ANSI_ARGS_((Widget w));
extern void cutRewriteValueAll _ANSI_ARGS_((Widget w));
extern void cutValueToPosition _ANSI_ARGS_((double start, double end));
extern void cut_outbuf_disp    _ANSI_ARGS_((void));
extern void grid_set           _ANSI_ARGS_((Widget w, int *tag,
					  caddr_t callback_data));

/* in tmpdir.c */
extern void init_temp _ANSI_ARGS_((char *WorkDir));
extern void free_temp _ANSI_ARGS_((void));

/* in fileIO.c */
extern void    write_type    _ANSI_ARGS_((char *format, char *type, int byte));
extern int     get_index     _ANSI_ARGS_((char *fname, int *index));
extern Buffer* ReadDataFile  _ANSI_ARGS_((char *fname, int num, int *leng));
extern int     WriteDataFile _ANSI_ARGS_((char *fname, int num, int leng,
					  Buffer *data, char *format,
					  char *type, int byte));
/* in graph.c */
extern void    writeLabel  _ANSI_ARGS_((int canvas, double max, double min,
					double left, double right));
extern void    myerase     _ANSI_ARGS_((int canvas));
extern void    zoom_in     _ANSI_ARGS_((Widget w, int *tag,
					caddr_t callback_data));
extern void    zoom_out    _ANSI_ARGS_((Widget w, int *tag,
					caddr_t callback_data));
extern void    redraw_proc _ANSI_ARGS_((Widget w, int *tag,
					caddr_t callback_data));
extern void    drawGraph   _ANSI_ARGS_((int canvas, Buffer *showbuf, int len));
extern void    resize_proc _ANSI_ARGS_((Widget w, int *tag,
					caddr_t callback_data));

/* in isop_get_set.c */
extern void     setValue     _ANSI_ARGS_((Widget w, char *value));
extern char    *getValue     _ANSI_ARGS_((Widget w));
extern void     setLabel     _ANSI_ARGS_((Widget w, char *value));
extern Boolean  getState     _ANSI_ARGS_((Widget w));
extern void     setState     _ANSI_ARGS_((Widget w, int state));

/* in isop_funcs.c */
extern void set_dpt          _ANSI_ARGS_((int dpt));
extern void set_freq         _ANSI_ARGS_((void));
extern void quit_by_error    _ANSI_ARGS_((int));
extern void quit_all         _ANSI_ARGS_((Widget widget, char *tag,
					  XmAnyCallbackStruct *callback_data));
extern void creat_status_box _ANSI_ARGS_((Widget w, int *tag,
					  XmAnyCallbackStruct *callback_data));
extern void status_set       _ANSI_ARGS_((Widget w, int *tag,
					  XmAnyCallbackStruct *callback_data));
extern void ibuf_set         _ANSI_ARGS_((Widget w, int *tag,
					  XmAnyCallbackStruct *callback_data));
extern void obuf_set         _ANSI_ARGS_((Widget w, int *tag,
					  XmAnyCallbackStruct *callback_data));
extern void creat_option_box _ANSI_ARGS_((Widget w, int *tag,
					  XmAnyCallbackStruct *callback_data));
extern void option_set       _ANSI_ARGS_((Widget w, int *tag,
					  XmAnyCallbackStruct *callback_data));
extern void fft2             _ANSI_ARGS_((double x[], double y[], int l,
					  double ainv));
extern void quit_proc        _ANSI_ARGS_((void));
extern void file_select      _ANSI_ARGS_((Widget w, int *tag,
					  XmAnyCallbackStruct *callback_data));
extern int  fs_exec_list     _ANSI_ARGS_((int number));
extern void set_write_type   _ANSI_ARGS_((Widget w, int *tag,
					  XmAnyCallbackStruct *callback_data));


#endif /* _ISOP_PROTO_H_ */
